/*
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/opensrc/kitty/RCS/CrtMessage.p,v 1.2 2002/05/04 18:47:12 sauge Exp $" NO-UNDO. 

DEF INPUT PARAMETER cSecUserID      AS CHARACTER NO-UNDO.
DEF INPUT PARAMETER cMsgSubject     AS CHARACTER NO-UNDO.
DEF INPUT PARAMETER cMsgText        AS CHARACTER NO-UNDO.
DEF INPUT PARAMETER cCollabGrpID    AS CHARACTER NO-UNDO.
DEF INPUT PARAMETER cParentMessage  AS CHARACTER NO-UNDO.

{MakeID3.i}

DEF BUFFER bCollabMsg FOR CollabMsg.

CREATE CollabMsg.
  
ASSIGN CollabMsg.CollabMsgID = MakeID3(10).

ASSIGN 
CollabMsg.SecUserID = cSecUserID
CollabMsg.MsgSubject = cMsgSubject
CollabMsg.MsgText = cMsgText
CollabMsg.CollabGrpID = cCollabGrpID.

ASSIGN CollabMsg.CreateDate = TODAY
       CollabMsg.CreateTime = TIME.

IF cParentMessage <> "" THEN
  ASSIGN CollabMsg.ParentMsgNumber = INT(cParentMessage).

/* Find the final message in the linked list for the message list */
 
FIND bCollabMsg EXCLUSIVE-LOCK 
WHERE bCollabMsg.CollabGrpID = cCollabGrpID
  AND bCollabMsg.LinkNextMsgNumber = ?
NO-ERROR.

/* This is the first one in the link! */
IF NOT AVAILABLE bCollabMsg THEN 
  ASSIGN CollabMsg.MsgNumber = 1
         CollabMsg.LinkNextMsgNumber = ?
         CollabMsg.LinkPrevMsgNumber = ?.
ELSE 
  ASSIGN CollabMsg.MsgNumber = bCollabMsg.MsgNumber + 1
         CollabMsg.LinkPrevMsgNumber = bCollabMsg.MsgNumber
         CollabMsg.LinkNextMsgNumber = ?
         bCollabMsg.LinkNextMsgNumber = CollabMsg.MsgNumber.

