/*
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header$" NO-UNDO.

/* This is going to have to come from the CollabGrp in the future */

&GLOBAL-DEFINE	SBJPREFIX	"yourdomain.com:"
&GLOBAL-DEFINE	FROMADDR	"no-reply@yourdomain.com"

DEF VAR cCollabGrpID      AS CHARACTER NO-UNDO.
DEF VAR cCollabMsgNumber  AS CHARACTER NO-UNDO.

DEF VAR cMailMsgText AS CHARACTER NO-UNDO.
DEF VAR cMailMsgSubject AS CHARACTER NO-UNDO.
DEF VAR lSuccessful AS LOGICAL NO-UNDO.

{AbbrRegard.i}

/* Pull in the record identifiers from the command line */

ASSIGN
cCollabGrpID = OS-GETENV("COLLABGRPID")
cCollabMsgNumber = OS-GETENV("COLLABMSG").

/* Collaboration Group the mailing is going out to */

FIND CollabGrp NO-LOCK
WHERE CollabGrp.CollabGrpID = cCollabGrpID
NO-ERROR.

/* The message that will be going into the email */

FIND CollabMsg NO-LOCK
WHERE CollabMsg.MsgNumber = INT(cCollabMsgNumber)
NO-ERROR.

ASSIGN 
cMailMsgSubject = {&SBJPREFIX} + AbbrRegard(CollabMsg.MsgSubject)
cMailMsgText = "<html>" + CollabMsg.MsgText + "</html>".

/* Pull up all the options of the collaboration group for Email */

FOR EACH CollabOpt OF CollabGrp 
WHERE CollabOpt.OptName = "Email"
  AND CollabOpt.OptValue = "YES" NO-LOCK:

  /* Walk the relations to get to the email address */

  FIND CollabGrpMbr OF CollabOpt NO-LOCK NO-ERROR.

  FIND Person OF CollabGrpMbr NO-LOCK NO-ERROR.
  
  FIND Contact OF Person NO-LOCK NO-ERROR.

  /* Call out into the mail system to issue the email */

  RUN smtpmail.p ("localhost",
                  Contact.Email,
                  {&FROMADDR},
                  "",
                  "",
                  "",
                  cMailMsgSubject,
                  cMailMsgText,
                  "type=text/html:charset=usascii",
                  "text",
                  OUTPUT lSuccessful).

END. /* FOR EACH CollabMbr OF CollabGrp */

